## mingw-w64-libbsdf-0.11.0-1.src.tar.zst

=== CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2014-2023 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

cmake_minimum_required(VERSION 3.5)

project(libbsdf)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

option(LIBBSDF_ENABLE_FITTING "Enable fitting functions with Ceres Solver" OFF)

set(HEADER_PATH include/libbsdf)
set(SOURCE_PATH src)

# Create groups for each directory and add file paths to the list of source code.
macro(set_sources DIR_NAME)
    file(GLOB GROUP_HEADERS "${HEADER_PATH}/${DIR_NAME}/*.h")
    file(GLOB GROUP_SOURCES "${SOURCE_PATH}/${DIR_NAME}/*.cpp")
    source_group("${DIR_NAME}\\Header Files" FILES ${GROUP_HEADERS})
    source_group("${DIR_NAME}\\Source Files" FILES ${GROUP_SOURCES})

    list(APPEND SOURCES ${GROUP_HEADERS} ${GROUP_SOURCES})
endmacro()

set(SOURCES)
set_sources(Brdf)
set_sources(Common)
if(LIBBSDF_ENABLE_FITTING)
    set_sources(Fitter)
endif()
set_sources(Reader)
set_sources(ReflectanceModel)
set_sources(Writer)

# Set delaunator-cpp.
set(DELAUNATOR_PATH src/ThirdParty/delaunator-cpp)
set(DELAUNATOR_SOURCES "${DELAUNATOR_PATH}/delaunator.hpp" "${DELAUNATOR_PATH}/delaunator.cpp")
source_group("ThirdParty\\delaunator-cpp" FILES ${DELAUNATOR_SOURCES})
list(APPEND SOURCES ${DELAUNATOR_SOURCES})

include_directories(include)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Eigen3 REQUIRED)
if(Eigen3_FOUND)
    message("Found Eigen-${Eigen3_VERSION}: ${Eigen3_DIR}")
    set(EIGEN3_LIB "Eigen3::Eigen")
endif()

if(LIBBSDF_ENABLE_FITTING)
    find_package(Ceres REQUIRED)
    set(CERES_LIB "Ceres::ceres")
    add_definitions(-DLIBBSDF_USE_CERES_SOLVER)
endif()

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
else()
    set(CMAKE_CXX_STANDARD 17)

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse3")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse3")
endif()

option(LIBBSDF_USE_OPENMP "Use OpenMP" ON)
if(LIBBSDF_USE_OPENMP)
    find_package(OpenMP QUIET)
    if(OPENMP_FOUND)
        message("OpenMP found")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
    endif()
endif()

add_library(${PROJECT_NAME} ${SOURCES})

option(LIBBSDF_BUILD_APPLICATIONS "Enable to build libbsdf Applications" ON)
if(LIBBSDF_BUILD_APPLICATIONS)
    add_subdirectory(applications)

    if(NOT DEFINED LIBBSDF_CORE_FOLDER_NAME)
        set(LIBBSDF_CORE_FOLDER_NAME Core)
    endif()

    set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_CORE_FOLDER_NAME})
endif()

target_link_libraries(${PROJECT_NAME} Eigen3::Eigen ${CERES_LIB})

=== applications/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2018-2023 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(applications)

set(UTILITY_SOURCE_PATH Utility)
file(GLOB UTILITY_SOURCES
     "${UTILITY_SOURCE_PATH}/*.h"
     "${UTILITY_SOURCE_PATH}/*.cpp"
     "${UTILITY_SOURCE_PATH}/*.c")

find_package(Eigen3 REQUIRED)

if(NOT DEFINED LIBBSDF_APPLICATION_FOLDER_NAME)
    set(LIBBSDF_APPLICATION_FOLDER_NAME Applications)
endif()

include_directories(${UTILITY_SOURCE_PATH})
set(UTILITY_LIB_NAME AppUtility)
add_library(${UTILITY_LIB_NAME} ${UTILITY_SOURCES})
set_target_properties(${UTILITY_LIB_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

target_link_libraries(${UTILITY_LIB_NAME} libbsdf Eigen3::Eigen)

add_subdirectory(lbanalyze)
add_subdirectory(lbaverage)
add_subdirectory(lbcombine)
add_subdirectory(lbcompare)
add_subdirectory(lbconv)

if(LIBBSDF_ENABLE_FITTING)
    add_subdirectory(lbfit)
endif()

add_subdirectory(lbgen)
add_subdirectory(lbidentify)
add_subdirectory(lbinsert)

=== applications/lbanalyze/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2019-2022 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbanalyze)

set(SOURCES lbanalyze.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== applications/lbaverage/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2019-2022 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbaverage)

set(SOURCES lbaverage.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== applications/lbcombine/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2020-2022 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbcombine)

set(SOURCES lbcombine.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== applications/lbcompare/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2019-2022 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbcompare)

set(SOURCES lbcompare.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== applications/lbconv/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2019-2022 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbconv)

set(SOURCES lbconv.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== applications/lbfit/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2022 Kimura Ryo                                       ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbfit)

set(SOURCES lbfit.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== applications/lbgen/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2018-2022 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbgen)

set(SOURCES lbgen.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== applications/lbidentify/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2019-2022 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbidentify)

set(SOURCES lbidentify.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== applications/lbinsert/CMakeLists.txt ===
## =================================================================== ##
## Copyright (C) 2019-2022 Kimura Ryo                                  ##
##                                                                     ##
## This Source Code Form is subject to the terms of the Mozilla Public ##
## License, v. 2.0. If a copy of the MPL was not distributed with this ##
## file, You can obtain one at http://mozilla.org/MPL/2.0/.            ##
## =================================================================== ##

project(lbinsert)

set(SOURCES lbinsert.cpp)

include_directories(../${UTILITY_SOURCE_PATH})

add_executable(${PROJECT_NAME} ${SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${LIBBSDF_APPLICATION_FOLDER_NAME})

if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()

target_link_libraries(${PROJECT_NAME} ${UTILITY_LIB_NAME} libbsdf)

=== PKGBUILD ===
# Maintainer: Marko Käning <mk-lists@mailbox.org>
# Contributor: Andrew Sun <adsun701@gmail.com>

_realname=libbsdf
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.11.0
pkgrel=1
epoch=
pkgdesc="Library for handling BSDF files (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64' 'clang32')
url='https://github.com/KimuraRyo/libbsdf'
license=('spdx:MPL-2.0')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3")
source=(${_realname}-${pkgver}.tar.gz::"https://github.com/KimuraRyo/${_realname}/archive/v${pkgver}.tar.gz")
sha256sums=('1f830d4a28b0c81b77ef4bfd0d8e2dadf46b4369e4d53f43a37d761566387411')

build() {
  [[ -d build-${MSYSTEM} ]] && rm -rf build-${MSYSTEM}
  mkdir build-${MSYSTEM} && cd build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_BUILD_TYPE=Release \
    -DEIGEN3_INCLUDE_DIR=${MINGW_PREFIX}/include/eigen3 \
    ${extra_config[@]} \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  mkdir -p ${pkgdir}${MINGW_PREFIX}/share/licenses/libbsdf
  cp -f "${srcdir}"/${_realname}-${pkgver}/LICENSE ${pkgdir}${MINGW_PREFIX}/share/licenses/libbsdf

  mkdir -p ${pkgdir}${MINGW_PREFIX}/include
  cp -rf "${srcdir}"/${_realname}-${pkgver}/include/libbsdf ${pkgdir}${MINGW_PREFIX}/include/

  mkdir -p ${pkgdir}${MINGW_PREFIX}/lib
  cp -f "${srcdir}"/build-${MSYSTEM}/liblibbsdf.a ${pkgdir}${MINGW_PREFIX}/lib/
}
